import java.util.Scanner;


public class Main {
	static class node {
		int k;
		node l, r;
		
		node(int init) {
			k = init;
			l = r = null;
		}
		int size() {
			return 1 + (l == null ? 0 : l.size()) + (r == null ? 0 : r.size());
		}
		void add(int n) {
			if (n < k) {
				if (l == null) l = new node(n);
				else l.add(n);
			}
			else {
				if (r == null) r = new node(n);
				else r.add(n);
			}
		}
	}
	
	static node a, b;
	
	static int convert(node l, node r) {
		if (l == null) return r == null ? 0 : r.size();
		if (r == null) return 1;
		if (l.k == r.k) return convert(l.l, r.l) + convert(l.r, r.r);
		return r == null ? 1 : 1 + r.size();
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int case_num = 1;
		while (true) {
			a = b = null;
			int size_a = in.nextInt();
			if (size_a == -1) break;
			for (int i = 0; i < size_a; i++) {
				int next = in.nextInt();
				if (a == null) a = new node(next);
				else a.add(next);
			}
			int size_b = in.nextInt();
			for (int i = 0; i < size_b; i++) {
				int next = in.nextInt();
				if (b == null) b = new node(next);
				else b.add(next);
			}
			int t = convert(a, b);
			if (t == 1) System.out.println("Case " + case_num++ + ": 1 command.");
			else System.out.println("Case " + case_num++ + ": " + t + " commands.");
		}
	}
}
