import java.io.*;
import java.util.*;

class tantrix
{
	public static void main(String args[])
	{
		tantrix obj = new tantrix();
		obj.runit();
	};

	void runit()
	{
		int status = 0;
		int numtests = 0;
		int numtiles = 0;
				
		Scanner sc = new Scanner(System.in);
		Grid grid = new Grid();
		Tile hand[];
		do
		{
		switch (status)
		{
		case 0: //read a line
			numtests = sc.nextInt();
			numtiles = 0;
			
			status = 1;
			break;
		case 1:
			grid = new Grid();	
			numtiles = sc.nextInt();
			
			int x = 0; int y = 0;
			Tile input;
			
			for (int i = 0; i < numtiles; i++)
			{
				x = sc.nextInt();
				y = sc.nextInt();
				input = new Tile(sc.next());
				grid.placeTile(x+30,y+30, input);
				//System.out.println(x + " " + y + " " + input.color);				
			};
			status = 2;
			break;
		case 2:	
			String line = sc.nextLine();
			line = sc.nextLine(); //take on the real thing...
			int count = (line.length()+1) / 7;
			//System.out.println(line.length());
			//System.out.println(count);
			hand = new Tile[count];
			for (int i = 0; i < count; i++)
			{
				//System.out.println(i*7 + " " + (i*7+6));
				String real = line.substring(i*7, i*7+6);
				//System.out.println(real);
				hand[i] = new Tile(real);
			};
			System.out.println(grid.checkMoves(hand,count));
			numtests = numtests - 1;
			if (numtests == 0) return;
			status = 1;
			break;
		


		};
		}
		while (status < 5);
	};
};

class Grid
{
	
	//boolean checkForced();
	Tile tiles[][];
	boolean blocked[][];
	int boundcount[][];
	boolean forced;
	boolean foundforced;
	int movecount;
	//void blockForced();
	Grid()
	{
		tiles = new Tile[60][60];
		blocked = new boolean[60][60];
		boundcount = new int[60][60];
		forced = false;
		foundforced = false;
		movecount = 0;
	};
	void placeTile(int x, int y, Tile newtile)
	{
		tiles[x][y] = newtile;
	};
	
	int checkMoves(Tile hand[],int count)
	{
		int i, j;
		for (j = 1; j < 59; j++)		
		{
		for (i = 1; i < 59; i++)
		{
			if (!(tiles[i][j] == null))
			{
				//System.out.println("Adding bounds due to " + (i-20) + " " + (j-20));
				boundcount[i+1][j]++;
				boundcount[i-1][j]++;
				boundcount[i+1][j-1]++;
				boundcount[i-1][j+1]++;
				boundcount[i][j+1]++;
				boundcount[i][j-1]++;
			};
			//System.out.print(boundcount[i][j]);
		};
			//System.out.println();
		};	
		for (j = 0; j < 60; j++)
		for (i = 0; i < 60; i++) 
		{
			if ((boundcount[i][j] >= 3) && (tiles[i][j] == null))
			{
				forced = true;
				String match = getMatchString(i,j);
				
				for (int z = 0; z < count; z++)
				{
					//if (hand[z].matchesInput(match)) movecount++;
					movecount+= hand[z].matchesInput(match);
				};
				//System.out.println(movecount);
				blockTiles(i,j);			
			};			
			//System.out.println((i-20) + " " + (j-20) + " " + boundcount[i][j]);
		};
		//System.out.println("Movecount" + movecount);
		if ((forced) && (movecount > 0)) return movecount;
		
		for (j = 0; j < 60; j++)
		for (i = 0; i < 60; i++)
		{
			//if (blocked[i][j]) System.out.println((i -30)+ " " + (j - 30) + " is blocked");
			if ((!blocked[i][j]) && (boundcount[i][j] > 0) && (tiles[i][j] == null))
			{
				String match = getMatchString(i,j);
				//System.out.println("Match String: " + match);
				for (int z = 0; z < count; z++)
				{
					movecount+= hand[z].matchesInput(match);
					//if (hand[z].matchesInput(match)) movecount++;
				};
				//System.out.println(movecount);
			};


		};
		
			
		
		return movecount;
	};

	String getMatchString(int x, int y)
	{
		String match = ".*";
		String color = "";
		//System.out.println("Position: " + (x - 30) + " " + (y-30));	
		if (tiles[x][y+1] != null){ match += tiles[x][y+1].getColor(3); }
		else 
		{
			color = getDominantColor(x, y+1);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};
	
		if (tiles[x+1][y] != null){ match += tiles[x+1][y].getColor(4);}
		else 
		{
			color = getDominantColor(x+1, y);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};
		if (tiles[x+1][y-1] != null){ match += tiles[x+1][y-1].getColor(5); }
		else 
		{
			color = getDominantColor(x+1, y-1);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};
		if (tiles[x][y-1] != null){ match += tiles[x][y-1].getColor(0); }
		else 
		{
			color = getDominantColor(x, y-1);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};
		if (tiles[x-1][y] != null){ match += tiles[x-1][y].getColor(1);}
		else 
		{
			color = getDominantColor(x-1, y);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};		
		if (tiles[x-1][y+1] != null){ match += tiles[x-1][y+1].getColor(2);}
		else 
		{
			color = getDominantColor(x-1, y+1);
			if (color.length() > 0)	match += "[^"+color+"]";
			else match+=".";
		};
		match += ".*";
	return match;
	};
	
	String getDominantColor(int x, int y)
	{
		int total[] = new int[100]; //ascii crap
		if (tiles[x][y+1] != null)total[(int)tiles[x][y+1].getColor(3)]++;
		if (tiles[x+1][y] != null) total[(int)tiles[x+1][y].getColor(4)]++;
		if (tiles[x+1][y-1] != null) total[(int)tiles[x+1][y-1].getColor(5)]++; 
		if (tiles[x][y-1] != null) total[(int)tiles[x][y-1].getColor(0)]++;
		if (tiles[x-1][y] != null) total[(int)tiles[x-1][y].getColor(1)]++;		
		if (tiles[x-1][y+1] != null) total[(int)tiles[x-1][y+1].getColor(2)]++;
		String retval = "";
		for (int i = 0; i < 100; i++)
		{
			if (total[i] > 1) retval += (char)i;
		}; 
		//System.out.println("Dominant color of " + (x-30) + " " + (y-30) + " is " + retval);
		return retval;
	};

	void blockTiles(int i,int j)
	{
		int targeti = i; 
		int targetj = j;
				
		while ((tiles[targeti][targetj] == null) && (targeti < 59))
		{
			blocked[targeti][targetj] = true;			
			targeti++;
		};
		
		targeti = i;
		targetj = j;

		while ((tiles[targeti][targetj] == null) && (targeti > 0))
		{
			blocked[targeti][targetj] = true;
			targeti--;
		};
		targeti = i;
		targetj = j;
		while ((tiles[targeti][targetj] == null) && (targetj > 0))
		{
			blocked[targeti][targetj] = true;
			targetj--;
		};
		targeti = i;
		targetj = j;
		while ((tiles[targeti][targetj] == null) && (targetj < 59))
		{
			blocked[targeti][targetj] = true;
			targetj++;
		};
targeti = i;
		targetj = j;
		while ((tiles[targeti][targetj] == null) && (targeti > 0) && (targetj < 59))
		{
			blocked[targeti][targetj] = true;
			targeti--;
			targetj++;
		};
targeti = i;
		targetj = j;
		while ((tiles[targeti][targetj] == null) && (targetj > 0) && (targeti < 59))
		{
			blocked[targeti][targetj] = true;
			targeti++;
			targetj--;
		};

	};
};

class Tile
{
	public String color[];

	Tile(String input)
	{
		color = new String[6];
		color[0] = input; //allow for "wrapping"
		color[1] = input.substring(1,6) + input.substring(0,1);
		color[2] = input.substring(2,6) + input.substring(0,2);
		color[3] = input.substring(3,6) + input.substring(0,3);
		color[4] = input.substring(4,6) + input.substring(0,4);
		color[5] = input.substring(5,6) + input.substring(0,5);
		
	};
	
	int matchesInput(String input)
	{
		
		int successcount = 0;
		for (int i = 0; i < 6; i++)
		{
			//System.out.println("My color: " + color[i] + " and compare: " + input);
			if (color[i].matches(input)) successcount++;
		}
		return successcount;
	};
		
	char getColor(int position)
	{
		return color[0].charAt(position);
	};
};
