import java.io.*;
import java.util.*;

public class grass
{
    public static void main(String[] args)
    {
        int n, l;
        double w;
        Scanner fin = new Scanner (System.in);

        try {
        while (true)
        {
            //List<Rec> R = new ArrayList<Rec>();
            Set<Rec> R = new HashSet<Rec>();
            n = fin.nextInt();
            l = fin.nextInt();
            w = (double)fin.nextInt() / 2;
            for (int i = 0 ; i < n; i++)
            {
                int z = fin.nextInt();
                int r = fin.nextInt();
                if (r * r > w * w + 0.00001)
                    R.add(new Rec(z, r, w) );
            }
            /*
            Rec r0 = new Rec(-l, l, w); r0.p = l;
            Rec rn = new Rec(2*l, l, w); rn.p = l;
            R.add(r0);
            R.add(rn);
            RecComp comp = new RecComp(w);
            Collections.sort(R, comp);
            */
            
            /*
            for (Rec rr : R)
                System.out.println(rr);
                */
                

            int g = grass(R, l, w);
            System.out.println("" + g);
        }
        } catch (NoSuchElementException ex) {}

    }

    /* n^2 this up */
    public static int grass(Set<Rec> R, int l, double w)
    {
        List<Rec> U = new ArrayList<Rec>();
        RecComp2 comp2 = new RecComp2();
        double s = 0;
        while (s < l - 0.000001)
        {
            Set<Rec> T = new HashSet<Rec>();
            for (Rec r : R)
                if (r.u < s + 0.000001)
                    T.add(r);

            for (Rec t : T)
                R.remove(t);

            if (T.size() == 0) return -1;

            Rec m = Collections.max(T, comp2);
            U.add(m);
            s = m.v;
        }

        return U.size();

        /*
        for (int i = 0; i < R.size(); i += 1)
        {
            s = R.get(i).p + R.get(i).z;
            System.out.println(i + ": " + s);
            for (int j = i + 1; ; )
            {
                if (j == R.size())
                    return c;
                Set<Integer> T = new Set<Integer>();
            //System.out.println(j + ": " + R.get(j) + "considered (s=" + s + ")");
            System.out.println(j + ": z - p = " + ( (double)(R.get(j).z) - R.get(j).p) + " s=" + s);
                if ((double)(R.get(j).z) - R.get(j).p >= s - 0.00001)
                {
                    c += 1;
                    System.out.println("inc");
                    if ( i == j - 1) return -1;
                    i = j - 2;
                    break;
                }
                T.add(j);
                j += 1;
            }
        }
        */
    }
}

class RecComp2 implements Comparator<Rec>
{
    public double w;
    public int compare(Rec a, Rec b) 
    { 
        if (Math.abs(a.v - b.v) < 0.00001) return 0;
        return a.v > b.v ? 1 : -1 ;
    }
}

/*
class RecComp implements Comparator<Rec>
{
    public double w;
    public RecComp(double w) {this.w = w; }
    public int compare(Rec a, Rec b) 
    { 
        double u = (double)a.z - a.p;
        double v = (double)b.z - b.p;
        if (Math.abs(u - v) < 0.00001 ) return - (a.r - b.r) ;
        return u - v > 0 ? 1 : -1;
    }
}
*/

class Rec
{
    public int z, r;
    public double p;
    public double u, v;
    public Rec(int z, int r, double w) { this.z = z; this.r = r; this.p = proj(w); u = z-p; v = z+p; }
    public double proj( double w ) { return Math.sqrt((double)r * r - w * w); }
    public String toString () { return "[" + z + " " + r + " " + p + "] "; }
}
