# include <iostream>
# include <sstream>
# include <string.h>


using namespace std;

struct node {
  struct node *left;
  struct node *right;
  int key;
  int size;
} ;

typedef struct node Vertex;
   
int cpTrees (Vertex * a, Vertex *b) {
  //base
  if (a == NULL && b == NULL)
    return 0; 
  if (a == NULL && b != NULL)
    return b -> size;
  if (b == NULL)
    return a -> size;
  if (a -> key != b -> key) 
    return b -> size + 1;

  int l, r; 
  l = cpTrees (a -> left, b -> left);
  r = cpTrees (a -> right, b -> right);

  return l + r;
}

void bst (Vertex *r, int key) {
   if (r-> key == -1) {
    r -> left= (Vertex *) malloc (sizeof (Vertex));
    r -> left ->left =NULL;
    r -> left ->right =NULL;
    r -> left ->key = key;
    r -> left -> size = 1;
    return;
  }
  Vertex *a = r, *b;
  int lr;
  while (a != NULL) {
    if (key < a -> key) {
      a -> size ++;
      b = a; 
      a = a -> left;
      lr = 0;
    }
    else {
      a-> size ++;
      b=a;
      a = a -> right;
      lr =1;
    }
  }
  
  if (lr == 0) {
    b -> left =  (Vertex *) malloc (sizeof (Vertex));
    b -> left -> left = NULL;
    b -> left -> right = NULL;
    b -> left -> size = 1;
    b -> left -> key = key;
  }
  else if (lr == 1) {
    b -> right =  (Vertex *) malloc (sizeof (Vertex));
    b -> right -> left = NULL;
    b -> right -> right = NULL;
    b -> right -> size = 1;
    b -> right -> key = key;
  }

}

int main () {
  int x, y, k, i, case_num=1;
  
  char line [500];
  do {
    Vertex a,b;
    a.left = NULL;
    a.right =NULL;
    a.size =0;
    a.key =-1;
    b.left = NULL;
    b.right =NULL;
    b.size =0;
    b.key =-1;

    cin.getline (line, 500);
    if (strcmp (line, "-1") == 0)
      exit (0);


    stringstream ss; 
    ss << line; 
    
    ss >> x; 
    for (i = 0 ; i < x; i ++ ) {
      ss >> k;
      if (a.left == NULL)
      bst (&a, k);
      else 
        bst (a.left, k);
    }
    
    ss >> y;
    for (i = 0 ; i < y; i ++ ) {
      ss >> k; 
      if (b.left == NULL)
      bst (&b, k);
      else 
	bst (b.left, k);
    }
  
    int num = cpTrees (a.left, b.left);
    if (num==1 ) 
        cout << "Case " << case_num<< ": " << num<< " command."<< endl;    
    else
        cout << "Case " << case_num<< ": " << num<< " commands."<< endl;    
    case_num ++;
  
  }   while (true);
  return 1;
}
