import java.util.*;

class Main {
	public static void main(String args[]) {
		Scanner sc = new Scanner(System.in);
		while (sc.hasNextInt()) {
			int n = sc.nextInt();
			int l = sc.nextInt();
			int w = sc.nextInt();

			ArrayList<Sprinkler> sprinklers = new ArrayList<Sprinkler>();

			for (int i = 0; i < n; i++) {
				sprinklers.add(new Sprinkler(sc.nextInt(), sc.nextInt(), l, w));
			}
			
			int count = 0;
			
			double start = 0;
			
			double covered = 0;
			
			while(!sprinklers.isEmpty()) {
				Sprinkler max = null;
				for (Sprinkler sprinkler : sprinklers) {
					if(sprinkler.start - .00000001 <= start)
						if(max == null || sprinkler.covered + .00000001 > max.covered)
							max = sprinkler;
				}
				if(max == null)
					break;
				if(max.start - 0.00000001 > start)
					break;
				sprinklers.remove(max);
				start = max.end;
				covered += max.covered;
				count++;
				ArrayList<Sprinkler> remove = new ArrayList<Sprinkler>();
				for(Sprinkler sprinkler : sprinklers) { 
					if(sprinkler.start +.00000001 >= max.start && sprinkler.start -.00000001 <= max.end) {
						sprinkler.start = max.end;
					}
					if(sprinkler.end +.00000001 >= max.start && sprinkler.end -.00000001 <= max.end) {
						sprinkler.end = max.start;
					}
					sprinkler.covered = sprinkler.end - sprinkler.start;
					if(sprinkler.covered <= .00000001)
						remove.add(sprinkler);
				}
				for(Sprinkler sprinkler : remove) {
					sprinklers.remove(sprinkler);
				}
			}
			if(covered + .00000001 >= l) {
				System.out.println(count);
			} else {
				System.out.println(-1);
			}
		}
	}
}

class Sprinkler {
	int position, radius;
	double start, end, covered;

	public Sprinkler(int position, int radius, int l, int w) {
		this.position = position;
		this.radius = radius;

		double distance = Math.sqrt(radius * radius - (((double) w / 2))
				* (((double) w) / 2));

		start = position - distance;
		if (start < 0)
			start = 0;

		end = position + distance;
		if (end > l)
			end = l;
		
		covered = end - start;
	}
}