import java.math.*;
import java.util.Arrays;
import java.util.Scanner;
import java.io.*;

public class Main {

	public static void main(String args[]) throws Exception {
		Scanner in = new Scanner(System.in);
		 //in = new Scanner(new File("in.txt"));
		while (in.hasNextInt()) {
			int n = in.nextInt(); //num spinklers
			int l = in.nextInt();
			int w = in.nextInt();
			Sprinkler[] set = new Sprinkler[n]; 
			for (int i=0; i<n; i++) {
				set[i] = new Sprinkler(in.nextInt(), in.nextInt(), w);
			}
			
			Arrays.sort(set);
			
			for (int i=0; i<n; i++) {
				//System.out.println(set[i]);
			} 
			
			int numNeeded = 0;
			double pos=0;
			int j=0;
			
			while(j<n && pos<l) {
			
			double bestReach = -1;
			for (; j<n && set[j].start <= pos; j++) {
				if(set[j].end > bestReach ) bestReach = set[j].end;
			}
			if (bestReach <= pos)  {
				numNeeded = -1;
				break;
			}
			pos = bestReach;
			numNeeded++;
			}
			
			System.out.println(numNeeded);
			
			
		}
	}
	

}


class Sprinkler implements Comparable {

	public double start, end;
	public double f = 1e-6;
	
	public Sprinkler(int p, int r, int w) {
		double width = Math.sqrt( (r * r ) - ((w*w) / 4.0));
		//System.out.println(width);
		start = p - width - f;
		end = p + width + f;
		if (r<=(w/2)) {
			start = -1; end = -1;
		}
	}

	@Override
	public int compareTo(Object o) {
		Sprinkler s = (Sprinkler)o;
		if (this.start < s.start) return -1;
		if (this.start > s.start) return 1;
		return 0;
	}
	
	public String toString() {
		return start + " " + end;
	}
	
	
}