
import java.io.*;
import java.util.*;

public class ants
{
    public static void main(String[] args)
    {
        /*
        pt a = new pt(0, 0);
        pt b = new pt(1, 1);
        pt c = new pt(1, 3);
        pt d = new pt(1, 4);
        System.out.println(intercept(a, b, c, d));
        */
        int n;
        Scanner fin = new Scanner(System.in);
        while (true)
        {
            n = fin.nextInt();
            if (n == 0) break;

            pt[] A = new pt[n], T = new pt[n];

            for (int i = 0 ; i < n; i+= 1)
                A[i] = new pt(fin.nextInt(), fin.nextInt());
            for (int i = 0 ; i < n; i+= 1)
                T[i] = new pt(fin.nextInt(), fin.nextInt());

            int[] R = calc(A, T);
            for (int i : R)
                System.out.println("" + (i + 1));
        }
    }

    public static int[] calc(pt[] A, pt[] B)
    {
        int n = A.length;
        int[] R = new int[n];

        for (int i = 0 ;i < n; i ++)
            R[i] = i;
        
        while (true)
        {
            boolean inv = false;
            for (int i = 0 ; i < n; i++)
                for (int j = i+1; j < n; j++)
                {
                    pt a = A[i], b = B[R[i]], c = A[j], d = B[R[j]];
                    if (intercept(a, b, c, d))
                    {
                        int t = R[i];
                        R[i] = R[j];
                        R[j] = t;
                        inv = true;
                    }
                }
            if (inv == false)
                break;
        }
        return R;
    }

    public static boolean intercept(pt _a, pt _b, pt _c, pt _d)
    {
        pt b = new pt(_b.x - _a.x, _b.y - _a.y);
        pt c = new pt(_c.x - _a.x, _c.y - _a.y);
        pt d = new pt(_d.x - _a.x, _d.y - _a.y);

        pt e = new pt(_b.x - _d.x, _b.y - _d.y);
        pt f = new pt(_c.x - _d.x, _c.y - _d.y);
        pt g = new pt(_a.x - _d.x, _a.y - _d.y);

        return 
            (b.x * c.y > b.y * c.x == d.x * b.y > d.y * b.x) && 
            (f.x * g.y > f.y * g.x == e.x * f.y > e.y * f.x) ;
    }
}

class pt
{
    int x, y;
    public pt( int _x, int _y) {x = _x; y = _y; }
}
