import java.io.*;
import java.util.*;

class treemove
{
	public static void main(String args[])
	{
		treemove obj = new treemove();
		obj.runit();
	};

	void runit()
	{
		int status = 0;
		int casecount = 0;
		Tree a = new Tree(0);
		Tree b = new Tree(0);
		Scanner sc = new Scanner(System.in);
		
		do
		{
		switch (status)
		{
		case 0: 
			int asize = sc.nextInt();
			casecount++;
			if (asize == -1) return; //end of game
			int i;
			a = null;
			b = null;
			if (asize > 0)
			{
				a = new Tree(sc.nextInt());
				for (i = 1; i < asize; i++)
				{
					a.addValue(sc.nextInt());
				};
			}
			int bsize = sc.nextInt();
			//System.out.println(asize + "  " + bsize);
			if (bsize > 0)
			{
				b = new Tree(sc.nextInt());
				for (i = 1; i < bsize; i++)
				{
					b.addValue(sc.nextInt());
				};
			};
			status = 1;
			break;
		case 1:
			//loop over trees and count operations;
			int commandcount = comparetrees(a,b);
			System.out.print("Case " + casecount + ": " + commandcount);
			if (commandcount == 1) System.out.println(" command."); 
			else System.out.println(" commands.");
			status = 0;
			break;
		};
		}
		while (status < 5);

	};

	int comparetrees(Tree a,Tree b)
	{
		int commandcount = 0;
		if ((a == null) && (b ==null)) return 0;
		if ((a != null) && (b == null)) return 1; //delete
		if ((a == null) && (b != null)) return b.commandcount;
		if ((a.value != b.value)) return b.commandcount + 1; //for a delete.
		return comparetrees(a.left, b.left) + comparetrees(a.right, b.right);
	};
	


	// input a letter.
};

class Tree
{
	public int value;
	public int commandcount;
	public Tree left;
	public Tree right;
	Tree(int input)
	{
		//System.out.println("Creating tree - value: " + input);
		value = input;
		commandcount = 1;
	}	
	
	void addValue(int input)
	{
		commandcount++;
		if (input < value)
		{
			if (left == null) left = new Tree(input); else left.addValue(input);			
		};
		if (input > value)
		{
			if (right == null) right = new Tree(input); else right.addValue(input);			
		};
		//System.out.println("I am: "+ value + " and I have " + commandcount);
		
	};
}